package ga.cellular;

import laboratory.common.Loader;
import laboratory.common.ga.GA;
import laboratory.common.ga.IndividualFactory;
import laboratory.util.Parser;

import java.io.IOException;
import java.util.Properties;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;

/**
 * @author Andrey Davydov, Dennis Yolkin
 */
public class CellularGALoader implements Loader<GA> {

    private final Parser properties;

    public CellularGALoader(JarFile file) {
        Properties in = new Properties();
        try {
            JarEntry ent = new JarEntry("cellularGA.conf");
            in.load(file.getInputStream(ent));
        } catch (IOException e) {
            e.printStackTrace();
        }
        properties = new Parser(in);
    }

    public GA load(Object... args) {
		  return new CellularGA(properties.getInt("sizeGeneration"), properties.getDouble("sizeElite"),
                 properties.getDouble("probabilityMutation"),
                (IndividualFactory) args[0]);
    }

    public Properties getProperties() {
        return properties.getProperties();
    }
}
