package individual.BS;

import java.util.Random;
import laboratory.common.ga.IndividualFactory;
import task.ant.extended.Ant;

public class BSAutomatonFactory implements IndividualFactory {

    private final Random r = new Random();
    public static int attempts;
    private final double mu;
    private final int statesNumber;

    public BSAutomatonFactory( int statesNumber, double mu ) {
        this.statesNumber = statesNumber;
        this.mu = mu;
    }

    public BSAutomaton randomIndividual() {
        BSAutomaton ant = new BSAutomaton( statesNumber, r.nextInt( statesNumber ), mu);

        for (int i = 0; i < statesNumber; i++) {
            for (int j = 0; j < 256; j++) {
                switch (r.nextInt(3)) {
                    case 0:
                        ant.autom.setAction(i, j, Ant.Action.L);
                        break;
                    case 1:
                        ant.autom.setAction(i, j, Ant.Action.M);
                        break;
                    case 2:
                        ant.autom.setAction(i, j, Ant.Action.R);
                        break;
                }
                ant.autom.setNextState(i, j, r.nextInt(statesNumber + 1) - 1);
            }
        }
        return ant;
    }
}
